
import com.ewon.ewonitf.IOTag;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.Date;
import java.util.Vector;
import javax.microedition.io.Connector;
import javax.microedition.io.SocketConnection;
import javax.microedition.io.file.FileConnection;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author eWonSupport_Adm
 */

      //String request = "xml=<cmd compress=\"0\" lang=\"fre\" arg3=\"1\" configuretype=\"0\" arg2=\"2\" password=\"12345\" tableaddress=\"20018\" table_name=\"\" version=\"C\" stype=\"2\" arg1=\"1\" old_cfgtype=\"0\" nodetype=\"16\" bpidx=\"1\" listcombo=\"5\" combo=\"5\" action=\"read_list\" user=\"Supervisor\" />";
            
            //String request = "xml=<cmd compress=\"0\" password=\"12345\" user=\"Supervisor\" action=\"read_date_time\"/>";
         
            //Read temp with address
            //String request = "xml=<cmd compress=\"0\" action=\"read_val\"><val nodetype=\"16\" node=\"2\" vid=\"2530\" cid=\"0\" /></cmd>";
            
            //Read temp with name
            //String request = "xml=<cmd compress=\"0\" action=\"read_val\"><val nodetype=\"16\" node=\"2\" tag=\"evapintemp1\" /></cmd>";
            
            //Get Tag List
            //String request = "xml=<cmd compress=\"0\" password=\"12345\" user=\"Supervisor\" action=\"read_parm_info\" device_id=\"084B8030_018x\"></cmd>";

public class DanfossWebClient {
    
        private static SocketConnection sc  = null;
        private static DataOutputStream os = null;
        private static DataInputStream  is  = null;
        private static boolean isConnectedHTTP = false;
        
        public static String ServerIP = null;
        public static String UserName = null;
        public static String PassWord = null;        
        public static String Port = null;

        
        public static boolean ActivateDanfossLog= false;
        
    
        public static void OpenHTTPConnection() throws Exception
        {
            String connectString = "socket://"+ServerIP+ ":" + Port;

            try
            {
                if (isConnectedHTTP == false)
                {
                    // a socket connection is established with the remote server.
                    sc = (SocketConnection) Connector.open(connectString);

                    os = sc.openDataOutputStream();
                    is = sc.openDataInputStream();
                    isConnectedHTTP = true;
                }
                
            }
            catch (Exception e)
            {
                Exception newException = new Exception("DANFOSS ERROR (OpenHTTPConnection): " + e.getMessage());
                throw newException;
            }

        }
    
        public static void CloseHTTPConnection() throws Exception
        {
            try {
               if (isConnectedHTTP == true)
               {                
                    is.close();
                    os.close();
                    sc.close();
                    isConnectedHTTP = false;
               }
            } catch (Exception e) {
                Exception newException = new Exception("DANFOSS ERROR (CloseHTTPConnection): " + e.getMessage());
                throw newException;
            }
        }
    
        public static String Read_val(Vector TagToRead) throws Exception
        {
            try {
                
                
                //Compute Request
                //------------------
                String Request = "xml=<cmd compress=\"0\" password=\"" +   PassWord + 
                        "\" user=\"" + UserName + 
                        "\" action=\"read_val\">";
                
                
                for(int i=0;i<TagToRead.size();i++)   
                {  
                       IOTag myTag = (IOTag) TagToRead.elementAt(i);

                       String szNode = Utils.Split(myTag.getIoName(),",",1);
                       String szAddress = Utils.Split(myTag.getIoName(),",",2);                       
                       String szCid = Utils.Split(myTag.getIoName(),",",2);
                       String szVid = Utils.Split(myTag.getIoName(),",",3); 
                           
                        if ("".equals(szVid))
                        {
                            Request +=  "<val nodetype=\"16\" node=\"" + 
                                szNode +"\" tag=\"" + szAddress+ "\" />";
                        }
                        else                    
                        {
                            Request +=  "<val nodetype=\"16\" node=\"" + 
                                szNode +"\" cid=\"" + szCid+ "\" vid=\"" + szVid+ "\" />";
                        }
                       
                }
            
                
                Request += "</cmd>";
                //------------------
                
                CreateLogFile("Danfoss",Request);
                
                String HTTPResponse = PostXMLData(Request);
                               
                CreateLogFile("Danfoss",HTTPResponse);
   
                //read value from XML Response
                String Xmlresponse = HTTPResponse.substring(HTTPResponse.indexOf("\r\n\r\n")+ 4); //get rid of HTTP header
                /*String XmlTagToGet = "parval=\"";
                int PosStart = Xmlresponse.indexOf(XmlTagToGet);
                
                if (PosStart == -1)
                {
                     Exception newException = new Exception("DANFOSS ERROR (ReadTag): No parval attribute in xml");
                     throw newException;
                }
                
                PosStart = PosStart + XmlTagToGet.length();
                
                int PosEnd = Xmlresponse.indexOf("\"", PosStart);
                
                CreateLogFile("Danfoss","New Value:" +  Xmlresponse.substring(PosStart, PosEnd));
                
                return Xmlresponse.substring(PosStart, PosEnd);*/
                return Xmlresponse;
                
            } catch (Exception e) {
                Exception newException = new Exception("DANFOSS ERROR (ReadTag): " + e.getMessage());
                throw newException;
            }

        }
        
         public static String Read_sensor(Vector TagToRead) throws Exception
        {
            try {
 
                    
                //Compute Request
                //------------------
                String Request = "xml=<cmd compress=\"0\" password=\"" +   PassWord + 
                        "\" user=\"" + UserName + 
                        "\" action=\"read_sensor\">";
                
                
                for(int i=0;i<TagToRead.size();i++)   
                {  
                       IOTag myTag = (IOTag) TagToRead.elementAt(i);

                       String szNode = Utils.Split(myTag.getIoName(),",",1);
                       String szMod = Utils.Split(myTag.getIoName(),",",2);                       
                       String szPoint = Utils.Split(myTag.getIoName(),",",3); 
                       
                       Request +=  "<sensor node=\"" + 
                            szNode +"\" mod=\"" + 
                            szMod+ "\" point=\"" + 
                            szPoint+ "\" />";                                       
                }            
                
                Request += "</cmd>";
                //------------------
                                
                CreateLogFile("Danfoss",Request);
                
                String HTTPResponse = PostXMLData(Request);
                               
                CreateLogFile("Danfoss",HTTPResponse);
   
                //read value from XML Response
                String Xmlresponse = HTTPResponse.substring(HTTPResponse.indexOf("\r\n\r\n")+ 4); //get rid of HTTP header
                /*String XmlTagToGet = "parval=\"";
                int PosStart = Xmlresponse.indexOf(XmlTagToGet);
                
                if (PosStart == -1)
                {
                     Exception newException = new Exception("DANFOSS ERROR (ReadTag): No parval attribute in xml");
                     throw newException;
                }
                
                PosStart = PosStart + XmlTagToGet.length();
                
                int PosEnd = Xmlresponse.indexOf("\"", PosStart);
                
                CreateLogFile("Danfoss","New Value:" +  Xmlresponse.substring(PosStart, PosEnd));
                
                return Xmlresponse.substring(PosStart, PosEnd);*/
                return Xmlresponse;
                
            } catch (Exception e) {
                Exception newException = new Exception("DANFOSS ERROR (ReadTag): " + e.getMessage());
                throw newException;
            }

        }
        
           public static String Read_meter() throws Exception
        {
            try {
 
                    
                //Compute Request
                //------------------
                String Request = "xml=<cmd compress=\"0\" password=\"" +   PassWord + 
                        "\" user=\"" + UserName + 
                        "\" action=\"read_meters\"></cmd>";
              
                                
                CreateLogFile("Danfoss",Request);
                
                String HTTPResponse = PostXMLData(Request);
                               
                CreateLogFile("Danfoss",HTTPResponse);
   
                //read value from XML Response
                String Xmlresponse = HTTPResponse.substring(HTTPResponse.indexOf("\r\n\r\n")+ 4); //get rid of HTTP header
                
                return Xmlresponse;
                
            } catch (Exception e) {
                Exception newException = new Exception("DANFOSS ERROR (ReadTag): " + e.getMessage());
                throw newException;
            }

        }
         
         public static boolean WriteTag(String TagAddress, String CID, String VID, String Node, String Value) throws Exception
        {
            try {
                
                String Request;
                
                 if ("".equals(VID))
                {
                  Request = "xml=<cmd compress=\"0\" password=\"" + PassWord + 
                        "\" user=\"" + UserName + 
                        "\" action=\"write_val\"><val nodetype=\"16\" node=\"" + 
                        Node +"\" tag=\"" + TagAddress+ "\" set=\""+ Value + "\" /></cmd>";
                }
                else                    
                {
                  Request =  "xml=<cmd compress=\"0\" password=\"" + PassWord + 
                        "\" user=\"" + UserName + 
                        "\" action=\"write_val\"><val nodetype=\"16\" node=\"" + 
                        Node +"\" cid=\"" + CID+ "\" vid=\"" + VID + "\" set=\""+ Value + "\" /></cmd>";

                }
                
                CreateLogFile("Danfoss",Request);
                
                String HTTPResponse = PostXMLData(Request);
                
                CreateLogFile("Danfoss",HTTPResponse);
                
                //read Error value from XML Response
                String Xmlresponse = HTTPResponse.substring(HTTPResponse.indexOf("\r\n\r\n")+ 4); //get rid of HTTP header
                String XmlTagToGet = "error=\"";
               
                int PosStart = Xmlresponse.indexOf(XmlTagToGet) + XmlTagToGet.length();
                if (PosStart == -1) //no Error tag
                    return true;
                
                int PosEnd = Xmlresponse.indexOf("\"", PosStart);
                        
                if ("0".equals(Xmlresponse.substring(PosStart, PosEnd)))
                    return true;
                else
                    return false;
                
            } catch (Exception e) {
                Exception newException = new Exception("DANFOSS ERROR (WriteTag): " + e.getMessage());
                throw newException;
            }
        }
        
         
        public static String[] ReadTimeDate() throws Exception
        {
        
            String Request =  "xml=<cmd compress=\"0\" password=\"" +   PassWord + 
                        "\" user=\"" + UserName + 
                        "\" action=\"read_date_time\"/>";
               
                
                CreateLogFile("Danfoss",Request);
                
                String HTTPResponse = PostXMLData(Request);
                
                CreateLogFile("Danfoss",HTTPResponse);
   
                String[] TimeArray = new String[9];
                
                //read value from XML Response
                String Xmlresponse = HTTPResponse.substring(HTTPResponse.indexOf("\r\n\r\n")+ 4); //get rid of HTTP header
              
                int PosStart = Xmlresponse.indexOf("<year>");
                
                if (PosStart == -1)
                {
                     Exception newException = new Exception("DANFOSS ERROR (ReadTag): No year tag in xml response");
                     throw newException;
                }
                
                PosStart = PosStart + "<year>".length();                     
                int PosEnd = Xmlresponse.indexOf("</year>");
                
                TimeArray[0] = Xmlresponse.substring(PosStart, PosEnd);
                            
                PosStart = Xmlresponse.indexOf("<month>") + "<month>".length() ;
                PosEnd = Xmlresponse.indexOf("</month>");
                
                TimeArray[1] = Xmlresponse.substring(PosStart, PosEnd);
                
                PosStart = Xmlresponse.indexOf("<day>") + "<day>".length() ;
                PosEnd = Xmlresponse.indexOf("</day>");
                
                TimeArray[2] = Xmlresponse.substring(PosStart, PosEnd);
                
                PosStart = Xmlresponse.indexOf("<hour>") + "<hour>".length() ;
                PosEnd = Xmlresponse.indexOf("</hour>");
                
                TimeArray[3] = Xmlresponse.substring(PosStart, PosEnd);
                
                PosStart = Xmlresponse.indexOf("<minute>") + "<minute>".length() ;
                PosEnd = Xmlresponse.indexOf("</minute>");
                
                TimeArray[4] = Xmlresponse.substring(PosStart, PosEnd);
                                  
                PosStart = Xmlresponse.indexOf("<second>") + "<second>".length() ;
                PosEnd = Xmlresponse.indexOf("</second>");
                
                TimeArray[5] = Xmlresponse.substring(PosStart, PosEnd);
                                         
                PosStart = Xmlresponse.indexOf("<epoch>") + "<epoch>".length() ;
                PosEnd = Xmlresponse.indexOf("</epoch>");
                
                TimeArray[6] = Xmlresponse.substring(PosStart, PosEnd);
        
                PosStart = Xmlresponse.indexOf("<timezone>") + "<timezone>".length() ;
                PosEnd = Xmlresponse.indexOf("</timezone>");
                
                TimeArray[7] = Xmlresponse.substring(PosStart, PosEnd);
                
                PosStart = Xmlresponse.indexOf("<daylightsavings>") + "<daylightsavings>".length() ;
                PosEnd = Xmlresponse.indexOf("</daylightsavings>");
                
                TimeArray[8] = Xmlresponse.substring(PosStart, PosEnd);
                
                return TimeArray;
            
        }
        
   
        
       
        private static String PostXMLData(String XMLData) throws Exception
        {
             try {
                StringBuffer sb = new StringBuffer();
                sb.append("POST /html/xml.cgi HTTP/1.1"+ "\r\n");
                sb.append("Content-Type: application/x-www-form-urlencoded").append("\r\n");
                sb.append("Host: ").append(ServerIP).append("\r\n");
                sb.append("Content-Length: ").append(String.valueOf(XMLData.length())).append("\r\n");                 
                sb.append("Connection: Keep-Alive"+ "\r\n\r\n");         
                sb.append(XMLData);
               
                String GetRequest = sb.toString();

                os.write(GetRequest.getBytes());

                /* Read Data */
                StringBuffer str = new StringBuffer();
                int  ch;

                while ((ch = is.read()) != -1)
                {
                    str.append((char)ch);
                }
                
                return str.toString();
                
            } catch (Exception e) {
                Exception newException = new Exception("DANFOSS ERROR (SendXMLData): " + e.getMessage());
                throw newException;
            }
        }
        
      static void CreateLogFile(String Filename, String Content)
    {
          try
            {
                if (!ActivateDanfossLog)
                    return;
                
                FileConnection fconn = 
                        (FileConnection) Connector.open("file:////usr/"+Filename+".log");
       
                   if(!fconn.exists())
                        fconn.create();
                   
                OutputStream Os = fconn.openOutputStream(fconn.fileSize());
                PrintStream ps = new PrintStream(Os);

                Date d = new Date();
                
                ps.println(d.toString() + "   " + Content + "\r\n");
                Os.close();
                ps.close();
                fconn.close();
                fconn = null;
                System.gc();
            }
            catch (Exception ioe)
            {
                System.out.println("Error CreateFile: "+ioe.toString());
            }
    }
}

