
import com.ewon.ewonitf.IOServer;
import com.ewon.ewonitf.IOTag;
import com.ewon.ewonitf.IOValue;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;
import javax.microedition.io.SocketConnection;

/*
 * To change this template, choose Tools | Templates and open the template in the editor.
 */
/**
 *
 * @author eWonSupport_Adm
 *
 *
 *
 * /**
 *
 * @author eWonSupport_Adm
 */
public class IOserver extends IOServer implements Runnable {

    //Array of Tags to read
    private Vector read_val_TagsList = new Vector();
    private Vector read_sensor_TagsList = new Vector();
    private Vector read_meter_TagsList = new Vector();
    //Array of Tags to write
    private Vector read_val_TagsList_Write = new Vector();
    private Vector read_val_TagsList_WriteValue = new Vector();
    //USER Params
    private int int_Debug = 0;
    private int int_PollRate = 5000;
    private int int_DelayBetweenPolls = 200;
    private int int_BlockSize = 10;
    //Constant
    private String sz_Variable = "VARIABLE";
    private String sz_Sensor = "SENSOR";
    private String sz_Meter = "METER";
    //POLLINGCYCLCOUNTER            
    private long int_Framecounter = 0;
    private IOTag ioTag_PollingCycleCounter = null;
    private String PollingCycleCounterAddress = "POLLINGCYCLECOUNTER";
    private IOTag ioTag_AK_Year = null;
    private String AKYearAddress = "AK_YEAR";
    private IOTag ioTag_AK_Month = null;
    private String AKMonthAddress = "AK_MONTH";
    private IOTag ioTag_AK_Day = null;
    private String AKDayAddress = "AK_DAY";
    private IOTag ioTag_AK_Hour = null;
    private String AKHourAddress = "AK_HOUR";
    private IOTag ioTag_AK_Minute = null;
    private String AKMinuteAddress = "AK_MINUTE";
    private IOTag ioTag_AK_Second = null;
    private String AKSecondAddress = "AK_SECOND";
    private IOTag ioTag_AK_Epoch = null;
    private String AKEpochAddress = "AK_EPOCH";
    private IOTag ioTag_AK_Timezone = null;
    private String AKTimeZoneAddress = "AK_TIMEZONE";
    private IOTag ioTag_AK_Daylight = null;
    private String AKDaylightAddress = "AK_TIMEZONE";
    SocketConnection sc = null;
    InputStream is = null;
    OutputStream os = null;

    public void onRegister() throws Exception {
        //setJavaReplyTimeout(1000000);   //Let Java freeze the eWON while debugging.
    }

    public IOserver() {
        super();
        setServerName("Danfoss");
        //setTagHelper("{\"topic\": {	\"\": [],	\"RET\": []}");
        setTagHelper("{\"Gram\":[{\"helpid\":\"0\",\"itemList\":[{\"i\":\"1\",\"v\":\"VARIABLE\",\"n\":\"1\"},{\"i\":\"2\",\"v\":\"SENSOR\",\"n\":\"5\"},{\"i\":\"3\",\"v\":\"METER\",\"n\":\"9\"}]},{\"helpid\":\"3\",\"itemList\":[{\"i\":\"4\",\"v\":\",\",\"t\":\"S\",\"n\":\"2\"}]},{\"helpid\":\"100\",\"itemList\":[{\"i\":\"101\",\"v\":[\"0\",\"255\"],\"t\":\"I\",\"o\":{\"op1\":\"y\"}},{\"i\":\"102\",\"coi\":{\"op1\":{\"v\":[\"y\"]}},\"v\":\",\",\"t\":\"S\",\"n\":\"3\"}]},{\"helpid\":\"200\",\"itemList\":[{\"i\":\"201\",\"v\":[\"0\",\"4194303\"],\"t\":\"I\",\"o\":{\"op2\":\"y\"}},{\"i\":\"202\",\"coi\":{\"op2\":{\"v\":[\"y\"]}},\"v\":\",\",\"t\":\"S\",\"n\":\"4\"}]},{\"helpid\":\"300\",\"itemList\":[{\"i\":\"301\",\"t\":\"I\",\"v\":[\"0\",\"4194303\"],\"ok\":\"1\"}]},{\"helpid\":\"3\",\"itemList\":[{\"i\":\"4\",\"v\":\",\",\"t\":\"S\",\"n\":\"6\"}]},{\"helpid\":\"400\",\"itemList\":[{\"i\":\"401\",\"v\":[\"0\",\"255\"],\"t\":\"I\",\"o\":{\"op1\":\"y\"}},{\"i\":\"402\",\"coi\":{\"op1\":{\"v\":[\"y\"]}},\"v\":\",\",\"t\":\"S\",\"n\":\"7\"}]},{\"helpid\":\"500\",\"itemList\":[{\"i\":\"501\",\"v\":[\"0\",\"4194303\"],\"t\":\"I\",\"o\":{\"op2\":\"y\"}},{\"i\":\"502\",\"coi\":{\"op2\":{\"v\":[\"y\"]}},\"v\":\",\",\"t\":\"S\",\"n\":\"8\"}]},{\"helpid\":\"600\",\"itemList\":[{\"i\":\"601\",\"t\":\"I\",\"v\":[\"0\",\"4194303\"],\"ok\":\"1\"}]},{\"helpid\":\"5\",\"itemList\":[{\"i\":\"5\",\"v\":\",\",\"t\":\"S\",\"n\":\"10\"}]},{\"helpid\":\"700\",\"itemList\":[{\"i\":\"701\",\"v\":[\"0\",\"255\"],\"t\":\"I\",\"o\":{\"op1\":\"y\"}},{\"i\":\"702\",\"coi\":{\"op1\":{\"v\":[\"y\"]}},\"v\":\",\",\"t\":\"S\",\"n\":\"11\"}]},{\"helpid\":\"800\",\"itemList\":[{\"i\":\"801\",\"v\":\"(()[^,]+)+\",\"t\":\"R\",\"ok\":\"1\"}]}],\"topic\":{\"A\":{\"startNodeId\":\"0\",\"gramAddrId\":\"0\"}},\"hlpTxt\":{\"0\":\"Enter the type of register\",\"4\":\"Node Address\",\"5\":\"Meter Id\",\"100\":\"Enter the Node Address\",\"101\":\"Node Address\",\"102\":\"Enter the CID\",\"200\":\"CID number\",\"201\":\"CID\",\"202\":\"VID\",\"300\":\"Enter the VID\",\"301\":\"VID\",\"400\":\"Enter the Node Address\",\"401\":\"Node Address\",\"402\":\"Mod Address\",\"500\":\"Enter the mod Address\",\"501\":\"Mod Address\",\"502\":\"Point Address\",\"600\":\"Enter the Point Address\",\"601\":\"Point Address\",\"700\":\"Enter the Meter Id\",\"701\":\"Meter Id\",\"702\":\"Parameter Name\",\"800\":\"Enter the Parameter Name\",\"801\":\"Parameter Name\"},\"opt\":{\"op1\":\"n\",\"op2\":\"n\"}}");
    }

    public void onPassConfig(boolean applyConfig, boolean checkConfig) throws Exception {
        DanfossWebClient.ServerIP = getConfigParam("ip", "192.168.110.2");
        DanfossWebClient.UserName = getConfigParam("username", "");
        DanfossWebClient.PassWord = getConfigParam("password", "");
        DanfossWebClient.Port = getConfigParam("port", "80");

        int_Debug = Integer.parseInt(getConfigParam("debug", "0"));
        int_PollRate = Integer.parseInt(getConfigParam("pollrate", "5000"));
        int_DelayBetweenPolls = Integer.parseInt(getConfigParam("delaybetweenpolls", "200"));
        int_BlockSize = Integer.parseInt(getConfigParam("blocksize", "10"));

        if (int_Debug == 1) {
            System.out.println("[DANFOSS] [DEBUG]: ip = " + DanfossWebClient.ServerIP);
        }
        if (int_Debug == 1) {
            System.out.println("[DANFOSS] [DEBUG]: port = " + DanfossWebClient.Port);
        }
        if (int_Debug == 1) {
            System.out.println("[DANFOSS] [DEBUG]: username = " + DanfossWebClient.UserName);
        }
        if (int_Debug == 1) {
            System.out.println("[DANFOSS] [DEBUG]: password = " + DanfossWebClient.PassWord);
        }
        if (int_Debug == 1) {
            System.out.println("[DANFOSS] [DEBUG]: debug = " + String.valueOf(int_Debug));
        }
        if (int_Debug == 1) {
            System.out.println("[DANFOSS] [DEBUG]: pollrate = " + String.valueOf(int_PollRate));
        }

    }

    public IOValue onGetIo(IOTag ioTag) throws Exception {
        return ioTag.getIoData();
    }

    public IOTag onGetIoInfo(String topicName, String ioName) throws Exception {

        IOTag ioTag;

        if (PollingCycleCounterAddress.equals(ioName) || AKDayAddress.equals(ioName)
                || AKDaylightAddress.equals(ioName) || AKEpochAddress.equals(ioName) || AKHourAddress.equals(ioName)
                || AKMinuteAddress.equals(ioName) || AKMonthAddress.equals(ioName) || AKSecondAddress.equals(ioName)
                || AKTimeZoneAddress.equals(ioName) || AKYearAddress.equals(ioName)) {
            ioTag = new IOTag(topicName, ioName, IOValue.DATATYPE_UINT32, true);
        } else {
            ioTag = new IOTag(topicName, ioName, IOValue.DATATYPE_FLOAT32, true);
        }

        ioTag.setQuality(IOTag.QUALITY_BAD);
        return ioTag;
    }

    public void onAdviseIo(IOTag ioTag) throws Exception {
        if (PollingCycleCounterAddress.equals(ioTag.getIoName())) {
            ioTag_PollingCycleCounter = ioTag;
            return;
        }

        if (AKYearAddress.equals(ioTag.getIoName())) {
            ioTag_AK_Year = ioTag;
            return;
        }

        if (AKMonthAddress.equals(ioTag.getIoName())) {
            ioTag_AK_Month = ioTag;
            return;
        }

        if (AKDayAddress.equals(ioTag.getIoName())) {
            ioTag_AK_Day = ioTag;
            return;
        }

        if (AKHourAddress.equals(ioTag.getIoName())) {
            ioTag_AK_Hour = ioTag;
            return;
        }

        if (AKMinuteAddress.equals(ioTag.getIoName())) {
            ioTag_AK_Minute = ioTag;
            return;
        }

        if (AKSecondAddress.equals(ioTag.getIoName())) {
            ioTag_AK_Second = ioTag;
            return;
        }

        if (AKEpochAddress.equals(ioTag.getIoName())) {
            ioTag_AK_Epoch = ioTag;
            return;
        }

        if (AKTimeZoneAddress.equals(ioTag.getIoName())) {
            ioTag_AK_Timezone = ioTag;
            return;
        }

        if (AKDaylightAddress.equals(ioTag.getIoName())) {
            ioTag_AK_Daylight = ioTag;
            return;
        }

        //If not a fixed tag -> Add to the list   
        if (sz_Variable.equals(Utils.Split(ioTag.getIoName(), ",", 0))) {
            read_val_TagsList.addElement(ioTag);
            return;
        }
        if (sz_Sensor.equals(Utils.Split(ioTag.getIoName(), ",", 0))) {
            read_sensor_TagsList.addElement(ioTag);
            return;
        }
        if (sz_Meter.equals(Utils.Split(ioTag.getIoName(), ",", 0))) {
            read_meter_TagsList.addElement(ioTag);
            return;
        }

        throw new Exception("Invalid Address");

    }

    public void onUnadviseIo(IOTag ioTag) throws Exception {

        if (PollingCycleCounterAddress.equals(ioTag.getIoName())) {
            ioTag_PollingCycleCounter = null;
        }

        if (sz_Variable.equals(Utils.Split(ioTag.getIoName(), ",", 0))) {
            read_val_TagsList.removeElement(ioTag);
        }


        if (sz_Sensor.equals(Utils.Split(ioTag.getIoName(), ",", 0))) {
            read_sensor_TagsList.removeElement(ioTag);
        }


    }

    public void onPutIo(IOTag ioTag, IOValue ioData) throws Exception {
        //In case of writing
        if (PollingCycleCounterAddress.equals(ioTag.getIoName())) {
            int_Framecounter = ioData.getUInt32();
        } else {
            if (int_Debug == 1) {
                System.out.println("[DANFOSS] [DEBUG]: Start Writing procedure for Tag " + ioTag.getIoName());
            }

            if (sz_Variable.equals(Utils.Split(ioTag.getIoName(), ",", 0))) {
                read_val_TagsList_Write.addElement(ioTag);
                read_val_TagsList_WriteValue.addElement(ioData);
            }

            if (sz_Sensor.equals(Utils.Split(ioTag.getIoName(), ",", 0))) {
                if (int_Debug == 1) {
                    System.out.println("[DANFOSS] [DEBUG]: Write not supported for Sensors");
                }
            }

        }

    }

    public void run() {
        while (true) {
            try {

                /*if (int_Debug == 1) {
                    DanfossWebClient.ActivateDanfossLog = true;
                } else {
                    DanfossWebClient.ActivateDanfossLog = false;
                }*/

                if (read_val_TagsList.isEmpty() && read_sensor_TagsList.isEmpty() && read_meter_TagsList.isEmpty()  ) {
                    if (int_Debug == 1) {
                        System.out.println("[DANFOSS] [DEBUG]: No tag to process");
                    }
                    Thread.sleep(5000);
                    continue;
                }

                if (DanfossWebClient.ServerIP == null) {
                    if (int_Debug == 1) {
                        System.out.println("[DANFOSS] [DEBUG]: Waiting for IOServer parameters");
                    }
                    Thread.sleep(5000);
                    continue;
                }

                // <editor-fold defaultstate="collapsed" desc="Read Time">                
                //Get Time, if one of the tags is defined at least

                if (ioTag_AK_Day != null || ioTag_AK_Epoch != null || ioTag_AK_Hour != null || ioTag_AK_Minute != null || ioTag_AK_Month != null
                        || ioTag_AK_Second != null || ioTag_AK_Timezone != null || ioTag_AK_Year != null || ioTag_AK_Daylight != null) {
                    DanfossWebClient.OpenHTTPConnection();

                    try {
                        String[] TimeArray = DanfossWebClient.ReadTimeDate();

                        if (ioTag_AK_Year != null) {
                            ioTag_AK_Year.setValueUInt32(Long.parseLong(TimeArray[0]));
                            postIoChange(ioTag_AK_Year);

                            if (ioTag_AK_Year.getQuality() == IOTag.QUALITY_BAD) {
                                ioTag_AK_Year.setQuality(IOTag.QUALITY_GOOD);
                                postQuality(ioTag_AK_Year);
                            }
                        }

                        if (ioTag_AK_Month != null) {
                            ioTag_AK_Month.setValueUInt32(Long.parseLong(TimeArray[1]));
                            postIoChange(ioTag_AK_Month);

                            if (ioTag_AK_Month.getQuality() == IOTag.QUALITY_BAD) {
                                ioTag_AK_Month.setQuality(IOTag.QUALITY_GOOD);
                                postQuality(ioTag_AK_Month);
                            }
                        }

                        if (ioTag_AK_Day != null) {
                            ioTag_AK_Day.setValueUInt32(Long.parseLong(TimeArray[2]));
                            postIoChange(ioTag_AK_Day);

                            if (ioTag_AK_Day.getQuality() == IOTag.QUALITY_BAD) {
                                ioTag_AK_Day.setQuality(IOTag.QUALITY_GOOD);
                                postQuality(ioTag_AK_Day);
                            }
                        }

                        if (ioTag_AK_Hour != null) {
                            ioTag_AK_Hour.setValueUInt32(Long.parseLong(TimeArray[3]));
                            postIoChange(ioTag_AK_Hour);

                            if (ioTag_AK_Hour.getQuality() == IOTag.QUALITY_BAD) {
                                ioTag_AK_Hour.setQuality(IOTag.QUALITY_GOOD);
                                postQuality(ioTag_AK_Hour);
                            }
                        }

                        if (ioTag_AK_Minute != null) {
                            ioTag_AK_Minute.setValueUInt32(Long.parseLong(TimeArray[4]));
                            postIoChange(ioTag_AK_Minute);

                            if (ioTag_AK_Minute.getQuality() == IOTag.QUALITY_BAD) {
                                ioTag_AK_Minute.setQuality(IOTag.QUALITY_GOOD);
                                postQuality(ioTag_AK_Minute);
                            }
                        }

                        if (ioTag_AK_Second != null) {
                            ioTag_AK_Second.setValueUInt32(Long.parseLong(TimeArray[5]));
                            postIoChange(ioTag_AK_Second);

                            if (ioTag_AK_Second.getQuality() == IOTag.QUALITY_BAD) {
                                ioTag_AK_Second.setQuality(IOTag.QUALITY_GOOD);
                                postQuality(ioTag_AK_Second);
                            }
                        }

                        if (ioTag_AK_Epoch != null) {
                            ioTag_AK_Epoch.setValueUInt32(Long.parseLong(TimeArray[6]));
                            postIoChange(ioTag_AK_Epoch);

                            if (ioTag_AK_Epoch.getQuality() == IOTag.QUALITY_BAD) {
                                ioTag_AK_Epoch.setQuality(IOTag.QUALITY_GOOD);
                                postQuality(ioTag_AK_Epoch);
                            }
                        }

                        if (ioTag_AK_Timezone != null) {
                            ioTag_AK_Timezone.setValueUInt32(Long.parseLong(TimeArray[7]));
                            postIoChange(ioTag_AK_Timezone);

                            if (ioTag_AK_Timezone.getQuality() == IOTag.QUALITY_BAD) {
                                ioTag_AK_Timezone.setQuality(IOTag.QUALITY_GOOD);
                                postQuality(ioTag_AK_Timezone);
                            }
                        }

                        if (ioTag_AK_Daylight != null) {
                            ioTag_AK_Daylight.setValueUInt32(Long.parseLong(TimeArray[8]));
                            postIoChange(ioTag_AK_Daylight);

                            if (ioTag_AK_Daylight.getQuality() == IOTag.QUALITY_BAD) {
                                ioTag_AK_Daylight.setQuality(IOTag.QUALITY_GOOD);
                                postQuality(ioTag_AK_Daylight);
                            }
                        }


                    } catch (Exception ex) {
                        System.out.println("DANFOSS ERROR: Cannot read date & time");
                        System.out.println("DANFOSS ERROR: " + ex.getMessage());

                        if (ioTag_AK_Year.getQuality() == IOTag.QUALITY_GOOD) {
                            ioTag_AK_Year.setQuality(IOTag.QUALITY_BAD);
                            postQuality(ioTag_AK_Year);
                            ioTag_AK_Month.setQuality(IOTag.QUALITY_BAD);
                            postQuality(ioTag_AK_Month);
                            ioTag_AK_Day.setQuality(IOTag.QUALITY_BAD);
                            postQuality(ioTag_AK_Day);
                            ioTag_AK_Hour.setQuality(IOTag.QUALITY_BAD);
                            postQuality(ioTag_AK_Hour);
                            ioTag_AK_Minute.setQuality(IOTag.QUALITY_BAD);
                            postQuality(ioTag_AK_Minute);
                            ioTag_AK_Second.setQuality(IOTag.QUALITY_BAD);
                            postQuality(ioTag_AK_Second);
                            ioTag_AK_Epoch.setQuality(IOTag.QUALITY_BAD);
                            postQuality(ioTag_AK_Epoch);
                            ioTag_AK_Timezone.setQuality(IOTag.QUALITY_BAD);
                            postQuality(ioTag_AK_Timezone);
                            ioTag_AK_Daylight.setQuality(IOTag.QUALITY_BAD);
                            postQuality(ioTag_AK_Daylight);
                        }
                    }

                    DanfossWebClient.CloseHTTPConnection();
                }

                // </editor-fold>

                int BlockNbr = 0;
                while (true) {
                    //Write Tags
                    WriteVariables();

                    // <editor-fold defaultstate="collapsed" desc="Read Variables Tags Loop">
                    //Read variables                                                          
                    Vector BlocOfTags = Utils.CopyVector(read_val_TagsList, int_BlockSize, BlockNbr);

                    if (BlocOfTags == null) {
                        //exit while loop
                        break;
                    }
                    
                    DanfossWebClient.OpenHTTPConnection();

                    if (int_Debug == 1) {
                        System.out.println("[DANFOSS] [DEBUG]: Read Variables, Send Request #" + BlockNbr);
                    }
                    String XmlResponse = DanfossWebClient.Read_val(BlocOfTags);
                    DanfossWebClient.CloseHTTPConnection();
                    BlockNbr++;
                    //End Read variables

                    //Process Response
                    for (int k = 0; k < BlocOfTags.size(); k++) {
                        IOTag VariableTag = (IOTag) BlocOfTags.elementAt(k);

                        String szNode = Utils.Split(VariableTag.getIoName(), ",", 1);
                        String szAddress = Utils.Split(VariableTag.getIoName(), ",", 2);
                        String szCid = Utils.Split(VariableTag.getIoName(), ",", 2);
                        String szVid = Utils.Split(VariableTag.getIoName(), ",", 3);

                        try {
                            float NewValue;

                            if ("".equals(szVid)) {
                                NewValue = Float.parseFloat(DanfossXMLParser.GetVariableByTagname(XmlResponse, szNode, szAddress));
                            } else {
                                NewValue = Float.parseFloat(DanfossXMLParser.GetVariableByCIDVID(XmlResponse, szNode, szCid, szVid));
                            }


                            if (int_Debug == 1) {
                                System.out.println("[DANFOSS] [DEBUG]: Value read for Tag " + VariableTag.getIoName() + " : " + String.valueOf(NewValue));
                            }

                            //Update value & quality only if it has changed.
                            if (VariableTag.getValueFloat32() != NewValue) {
                                VariableTag.setValueFloat32(NewValue);
                                postIoChange(VariableTag);
                                if (int_Debug == 1) {
                                    System.out.println("[DANFOSS] [DEBUG]: New value detected for Tag " + VariableTag.getIoName() + " : " + String.valueOf(NewValue));
                                }
                            }

                            if (VariableTag.getQuality() == IOTag.QUALITY_BAD) {
                                VariableTag.setQuality(IOTag.QUALITY_GOOD);
                                postQuality(VariableTag);
                            }

                        } catch (Exception ex) {
                            System.out.println("[DANFOSS] [ERROR]: Cannot read value of Tag " + VariableTag.getIoName());
                            System.out.println("[DANFOSS] [ERROR]: " + ex.getMessage());

                            if (VariableTag.getQuality() == IOTag.QUALITY_GOOD) {
                                VariableTag.setQuality(IOTag.QUALITY_BAD);
                                postQuality(VariableTag);
                            }
                        }
                    }
                    // </editor-fold>
                    Thread.sleep(int_DelayBetweenPolls);
                }



                // <editor-fold defaultstate="collapsed" desc="Read Sensors Tags Loop">
                //Read Sensors
                BlockNbr = 0;
                while (true) {

                    WriteVariables();

                    Vector BlocOfTags = Utils.CopyVector(read_sensor_TagsList, int_BlockSize, BlockNbr);

                    if (BlocOfTags == null) {
                        break;
                    }

                    DanfossWebClient.OpenHTTPConnection();

                    if (int_Debug == 1) {
                        System.out.println("[DANFOSS] [DEBUG]: Read Sensors, Send Request #" + BlockNbr);
                    }
                    String XmlResponse = DanfossWebClient.Read_sensor(BlocOfTags);
                    DanfossWebClient.CloseHTTPConnection();
                    BlockNbr++;
                    //End Read variables

                    //Process Response
                    for (int k = 0; k < BlocOfTags.size(); k++) {
                        IOTag SensorTag = (IOTag) BlocOfTags.elementAt(k);

                        String szNode = Utils.Split(SensorTag.getIoName(), ",", 1);
                        String szMod = Utils.Split(SensorTag.getIoName(), ",", 2);
                        String szPoint = Utils.Split(SensorTag.getIoName(), ",", 3);

                        try {
                            float NewValue;

                            NewValue = Float.parseFloat(DanfossXMLParser.GetSensor(XmlResponse, szNode, szMod, szPoint));

                            if (int_Debug == 1) {
                                System.out.println("[DANFOSS] [DEBUG]: Value read for Tag " + SensorTag.getIoName() + " : " + String.valueOf(NewValue));
                            }

                            //Update value & quality only if it has changed.
                            if (SensorTag.getValueFloat32() != NewValue) {
                                SensorTag.setValueFloat32(NewValue);
                                postIoChange(SensorTag);
                                if (int_Debug == 1) {
                                    System.out.println("[DANFOSS] [DEBUG]: New value detected for Tag " + SensorTag.getIoName() + " : " + String.valueOf(NewValue));
                                }
                            }

                            if (SensorTag.getQuality() == IOTag.QUALITY_BAD) {
                                SensorTag.setQuality(IOTag.QUALITY_GOOD);
                                postQuality(SensorTag);
                            }

                        } catch (Exception ex) {
                            System.out.println("[DANFOSS] [ERROR]: Cannot read value of Tag " + SensorTag.getIoName());
                            System.out.println("[DANFOSS] [ERROR]: " + ex.getMessage());

                            if (SensorTag.getQuality() == IOTag.QUALITY_GOOD) {
                                SensorTag.setQuality(IOTag.QUALITY_BAD);
                                postQuality(SensorTag);
                            }
                        }
                    }
                    // </editor-fold>                                        
                    Thread.sleep(int_DelayBetweenPolls);
                }

                
                // <editor-fold defaultstate="collapsed" desc="Read Meters Tags Loop">
                //Read Meters

                    WriteVariables();

                    DanfossWebClient.OpenHTTPConnection();

                    if (int_Debug == 1) {
                        System.out.println("[DANFOSS] [DEBUG]: Read Meters, Send Request #" + BlockNbr);
                    }
                    String XmlResponse = DanfossWebClient.Read_meter();
                    DanfossWebClient.CloseHTTPConnection();
                    BlockNbr++;
                    //End Read variables

                    //Process Response
                    for (int k = 0; k < read_meter_TagsList.size(); k++) {
                        IOTag MeterTag = (IOTag) read_meter_TagsList.elementAt(k);

                        String szMeterId = Utils.Split(MeterTag.getIoName(), ",", 1);
                        String szVarName = Utils.Split(MeterTag.getIoName(), ",", 2);
                  

                        try {
                            float NewValue;

                            NewValue = Float.parseFloat(DanfossXMLParser.GetMeterValue(XmlResponse, szMeterId, szVarName));

                            if (int_Debug == 1) {
                                System.out.println("[DANFOSS] [DEBUG]: Value read for Tag " + MeterTag.getIoName() + " : " + String.valueOf(NewValue));
                            }

                            //Update value & quality only if it has changed.
                            if (MeterTag.getValueFloat32() != NewValue) {
                                MeterTag.setValueFloat32(NewValue);
                                postIoChange(MeterTag);
                                if (int_Debug == 1) {
                                    System.out.println("[DANFOSS] [DEBUG]: New value detected for Tag " + MeterTag.getIoName() + " : " + String.valueOf(NewValue));
                                }
                            }

                            if (MeterTag.getQuality() == IOTag.QUALITY_BAD) {
                                MeterTag.setQuality(IOTag.QUALITY_GOOD);
                                postQuality(MeterTag);
                            }

                        } catch (Exception ex) {
                            System.out.println("[DANFOSS] [ERROR]: Cannot read value of Tag " + MeterTag.getIoName());
                            System.out.println("[DANFOSS] [ERROR]: " + ex.getMessage());

                            if (MeterTag.getQuality() == IOTag.QUALITY_GOOD) {
                                MeterTag.setQuality(IOTag.QUALITY_BAD);
                                postQuality(MeterTag);
                            }
                        }
                    }
                    // </editor-fold>                                        

                int_Framecounter++;
                if (ioTag_PollingCycleCounter != null) {
                    ioTag_PollingCycleCounter.setValueUInt32(int_Framecounter);
                    postIoChange(ioTag_PollingCycleCounter);
                }

                Thread.sleep(int_PollRate);
            } catch (Exception ex) {
                System.out.println("[DANFOSS] [ERROR]: " + ex.getMessage());
                try {
                    DanfossWebClient.CloseHTTPConnection();
                } catch (Exception ex1) {
                }
            }
        }
    }

    void WriteVariables() throws Exception {
        for (int j = 0; j < read_val_TagsList_Write.size(); j++) {
            IOTag myTag_toWrite = (IOTag) read_val_TagsList_Write.elementAt(j);
            IOValue ioData = (IOValue) read_val_TagsList_WriteValue.elementAt(j);

            DanfossWebClient.OpenHTTPConnection();

            String szNode = Utils.Split(myTag_toWrite.getIoName(), ",", 1);
            String szAddress = Utils.Split(myTag_toWrite.getIoName(), ",", 2);
            String szCid = Utils.Split(myTag_toWrite.getIoName(), ",", 2);
            String szVid = Utils.Split(myTag_toWrite.getIoName(), ",", 3);

            if (DanfossWebClient.WriteTag(szAddress, szCid, szVid, szNode, String.valueOf(ioData.getFloat32()))) {
                if (int_Debug == 1) {
                    System.out.println("[DANFOSS] [DEBUG]: Tag " + myTag_toWrite.getIoName() + " successfully written");
                }

                read_val_TagsList_Write.removeElementAt(j);
                read_val_TagsList_WriteValue.removeElementAt(j);
            } else {
                System.out.println("[DANFOSS] [ERROR]: Failed to write value in Tag " + myTag_toWrite.getIoName());
            }

            DanfossWebClient.CloseHTTPConnection();

            Thread.sleep(int_DelayBetweenPolls);
        }
    }
}
